#include "FFNNs.h"

//lbg[N̊wK
void  FFNNs::learnNetworks() {

#pragma omp parallel for
	for (int i = 0; i < NNs; i++) {
#ifndef _OPENMP 
		std::cout << "================" << i << "==================" << std::endl;
#endif 

		nns[i].eta = eta;
		nns[i].iterations = iterations;
		nns[i].batch_size = batch_size;

		nns[i].typeOfLearning = typeOfLearning;
		nns[i].mu = mu;
		nns[i].rho = rho;
		nns[i].lambda = lambda;

		nns[i].learnNetwork();

		lossVales[i] = nns[i].getMeanLossValue();

	}

	calculateNetworkRanking();
	std::cout << std::endl << "best network number: " << ranking[0] << std::endl;

}

//wKʂɂ郉LO쐬
void  FFNNs::calculateNetworkRanking() {

	bool* checkList = new bool[NNs];

	for (int nn = 0; nn < NNs; nn++) {
		checkList[nn] = false;
	}

	for (int nn = 0; nn < NNs; nn++) {

		double value;
		bool first = true;

		for (int i = 0; i < NNs; i++) {
			if (checkList[i]) continue;

			if (first) {
				value = lossVales[i];
				ranking[nn] = i;
				first = false;
			}
			else {
				if (lossVales[i] < value) {
					value = lossVales[i];
					ranking[nn] = i;
				}
			}
		}

		checkList[ranking[nn]] = true;

	}
	delete[] checkList;

	std::cout << std::endl << "============result============" << std::endl;

	for (int nn = 0; nn < NNs; nn++) {

		std::cout << "number: " << ranking[nn] << "  " << lossVales[ranking[nn]] << std::endl;
	}


	if (bestLossValue > lossVales[ranking[0]]) {

		bestLossValue = lossVales[ranking[0]];

		//dݍs̍Đݒ

		for (int n = 0; n < layerN-1; n++) {
			for (int i = 0; i < structure[n + 1]; i++) {
				for (int j = 0; j < structure[n]; j++) {

					W[n][i][j] = nns[ranking[0]].W[n][i][j];

				}
			}
		}
		//oCAXl̐ݒiŏIw͂Oj
		for (int n = 0; n < layerN-1; n++) {
			for (int i = 0; i < structure[n + 1]; i++) {
				B[n][i][0] = nns[ranking[0]].B[n][i][0];
			}
		}

		std::cout << "updateBestLossValue: " << bestLossValue << std::endl;

	}

}

//wK̏d݂ƃoCAXo
void FFNNs::dumpNetwork(std::ofstream &ofs_weight) {

	ofs_weight << "#W" << std::endl;

	//dݍs̐ݒ
	for (int n = 0; n < layerN-1; n++) {
		for (int i = 0; i < structure[n + 1]; i++) {
			for (int j = 0; j < structure[n]; j++) {
				ofs_weight << W[n][i][j];
				if (j < structure[n] - 1) ofs_weight << " ";
			}
			ofs_weight << std::endl;
		}
		ofs_weight << std::endl;
	}
	ofs_weight << std::endl << "#B" << std::endl;
	//oCAXl̐ݒiŏIw͂Oj
	for (int n = 0; n < layerN-1; n++) {
		for (int i = 0; i < structure[n + 1]; i++) {
			ofs_weight << B[n][i][0];
			if (i < structure[n + 1] - 1) ofs_weight << " ";
		}
		ofs_weight << std::endl;
	}

}

//wK̏d݂ƃoCAX̓ǂݍ
void FFNNs::readDumpNetwork(std::ifstream &if_weight) {
	std::string str;

	int flag = 0;
	int wn = 0, wi = 0;
	int bn = 0;
	while (getline(if_weight, str)) {
		if (str == "#W") flag = 1;
		if (str == "#B") flag = 2;
		if (str.find("#") != std::string::npos) continue;
		if (flag == 1) {
			if (str == "") {
				wn++;
				wi = 0;
				continue;
			}
			int wj = 0;
			std::istringstream iss(str);
			std::string s;
			while (iss >> s) {
				W[wn][wi][wj] = atof(s.c_str());
				//				std::cout << wn << " " << wi << " " << wj << " " << atof(s.c_str()) << std::endl;
				wj++;
			}
			wi++;
		}
		if (flag == 2) {
			int bi = 0;
			std::istringstream iss(str);
			std::string s;
			while (iss >> s) {
				B[bn][bi][0] = atof(s.c_str());
				//				std::cout << bn << " " << bi << " " << atof(s.c_str()) << std::endl;
				bi++;
			}
			bn++;
		}
	}

}

//ׂĂ̏d݂ƃoCAXǂݍ݃f[^ōĐݒ
void FFNNs::loadNetwork() {
	//dݍs̍Đݒ
	for (int nn = 0; nn < NNs; nn++) nns[nn].setW(W);
	//oCAXl̐ݒ
	for (int nn = 0; nn < NNs; nn++) nns[nn].setB(B);
}

//wKlbg[Npj[lbg[NvZs
void FFNNs::calculateByBestNeuralNetwork(double* _input, double* _output) {

	//dݍs̍Đݒ
	nns[ranking[0]].setW(W);
	//oCAXl̐ݒiŏIw͂Oj
	nns[ranking[0]].setB(B);

	nns[ranking[0]].calculateNeuralNetwork(_input, _output);
	//lossVales[ranking[0]] = nns[ranking[0]].getMeanLossValue();
	//	std::cout << "LossValue = "<<lossVales[ranking[0]] << " ;" << bestLossValue << std::endl;

}
//wKlbg[Npj[lbg[NvZsiϒlj
void FFNNs::calculateByMeanOfTopNeuralNetwork(int N, double* _input, double* _output) {

	//o͂̏
	double* output = new double[structure[layerN-1]];
	for (int i = 0; i < structure[layerN-1]; i++) {
		output[i] = 0;
		_output[i] = 0;
	}

	for (int nn = 0; nn < N; nn++) {

		nns[ranking[nn]].calculateNeuralNetwork(_input, output);
		for (int i = 0; i < structure[layerN-1]; i++) {
			_output[i] += output[i] / double(N);
		}

	}

	delete[] output;
}
//d݂ƃoCAXqݒ
void FFNNs::adoptFactor(double _weightFactor, double _biasFactor) {
	weightFactor = _weightFactor;
	biasFactor = _biasFactor;

	for (int i = 0; i < NNs; i++) {
		nns[i].adoptFactor(weightFactor, biasFactor);
	}

}

//ʃlbg[Nʃlbg[N֍XV
void FFNNs::updateLowerToHigher() {
	for (int nn = 0; nn < NNs / 2; nn++) {
		nns[ranking[NNs - nn - 1]].setW(nns[ranking[nn]].W);
		nns[ranking[NNs - nn - 1]].setB(nns[ranking[nn]].B);
	}
}