////////////////////////////////////////////////////////////////////
// |Ԉێ̋wKiRPUq^V~[Vj
////////////////////////////////////////////////////////////////////
#define _USE_MATH_DEFINES
#include <iostream>
#include <fstream>
#include <sstream>
#include <string>
#include <random>
#include <iomanip>
#include <time.h>
#include <direct.h>
#include <math.h>
#include <omp.h>

#include "Vector3.h"
#include "RK4_Nbody.h"
////////////////////////////////////////////////////////////////////
// p[^
////////////////////////////////////////////////////////////////////
//͈̔
double t_min = 0;
double t_max = 5.0;
double dt = 0.001;
//d͉x
double g = 10.0;
//Ђ̒
double L = 1.0;

//O͂̑傫
double fx_ext_max = 0.0;
double fx_ext_min = -0.0;

//d͉xxNg
Vector3 vec_g = Vector3(0, 0, -g);
//
double m_box = 100.0;
double m = 1.0;

//zPʃxNg
Vector3 z_hat(0, 0, 1);
Vector3 y_hat(0, 1, 0);

//␳p[^
double compensationK = 0.3; //␳΂˒eW
double compensationGamma = 0.000; //␳SRW

int error = 0;
////////////////////////////////////////////////////////////////////
// qNX
////////////////////////////////////////////////////////////////////
class Particles : public RK4_Nbody {
private:
public:
	//
	double fx = 0;
	double fx_ext = 0;

	//RXgN^
	Particles(int _N, double _dt) : RK4_Nbody(_N, _dt) {}

	//fXgN^
	~Particles() {
	}

	void A(double t, Vector3 *rs, Vector3 *vs, Vector3 *out_as) {
		for (int i = 0; i < N; i++) {
			out_as[i].set(0, 0, 0);
		}

		Vector3 a_box;
		a_box.set(fx / m_box, 0, 0);

		//xNg
		Vector3 vec_L = rs[1] - rs[0];
		//Αx
		Vector3 v_ij = vs[1] - vs[0];

		Vector3 a1_ext = vec_L;
		a1_ext.cross(y_hat);
		a1_ext.normalize();
		a1_ext = a1_ext * fx_ext / m;

		Vector3 vec_S = vec_L / (pow(vec_L.dot(z_hat), 2) / m_box - (m + m_box) / (m * m_box) * vec_L.lengthSq()) *
			(v_ij.lengthSq() + vec_g.dot(vec_L) - a_box.dot(vec_L));

		double Sz = vec_S.dot(z_hat);

		if (vec_L.length() > 1.1) {
			std::cout << t << " " << vec_L.length() << std::endl;
			std::cout << t << " " << rs[1].x << " " << rs[1].z << std::endl;
		}

		//␳
		Vector3 hatL = vec_L.clone().normalize();
		//␳΂˒e
		Vector3 fk = hatL.clone() * (-compensationK * (hatL.length() - L));
		//x␳
		Vector3 barV = v_ij.clone();
		//␳SR
		Vector3 fgamma = hatL.clone() * (-compensationGamma * barV.dot(hatL));

		//Ԃ։x
		out_as[0] = a_box - vec_S / m_box + Sz * z_hat / m_box - fk / m_box + fgamma / m_box;
		//Uq։x
		out_as[1] = vec_g + vec_S / m + a1_ext + fk / m - fgamma / m;

	};
};


////////////////////////////////////////////////////////////////////
// QwK
////////////////////////////////////////////////////////////////////
//wK
const int Episode = 10000;
//όvZ̊wK
const int ave_span = 100;
//wK
double eta = 0.01;
//
double gamma = 1.0;
//×~
double epsilon = 0.9;

//
const int N_f_box = 14;//2;
const int N_theta = 14;//4;

//sԊԊu
double interval = 0.05;

const int averageNum = 100;
const int parallelNum = 8;

//sl֐
double Q[averageNum][N_f_box + 1][N_theta];

double f_box_min = -10.0 * m_box;
double f_box_max = 10.0 * m_box;
double theta_min = -90.0;
double theta_max = 90.0;

int getThetaindex(Particles& particles) {
	double _theta = asin((particles.rs[1].x - particles.rs[0].x) / L) / M_PI * 180.0;

	//̈ʒuipxj
	for (int j = 0; j < N_theta; j++) {
		double theta = theta_min + (theta_max - theta_min) / N_theta * (j + 1);
		if (_theta < theta) {
			return j;
		}
	}
}

//EsV
double r_success = 9000.0;
double r_failure = 0.0;

//ϊi[p
double probabilityOfSuccess[averageNum][Episode / ave_span + 1];
int timesOfSuccess[averageNum];

////////////////////////////////////////////////////////////////////
// C֐
////////////////////////////////////////////////////////////////////
int main(void) {
#ifdef _OPENMP
	std::cout << "OpenMP : Enabled (Max # of threads = " << omp_get_max_threads() << ")" << std::endl;
	omp_set_num_threads(parallelNum);
#endif

	//tH_̐
	_mkdir("output");

	std::random_device rnd; //񌈒Iȗ
	std::mt19937 mt;        //32rbgŃZkEcCX^
	mt.seed(rnd());         //̎^
	std::uniform_real_distribution<> rand_real_0_1(0, 1.0); //urand_real_0_1(mt)vPsłP̗𐶐

#pragma omp parallel for
	for (int ave = 0; ave < averageNum; ave++) {
		//QNb^IuWFNg̐
		Particles particles(2, dt);

		double eta = 0.1;
		double epsilon = 0.1;

		int success = 0;
		for (int episode = 0; episode <= Episode; episode++) {

			int ebase = Episode / 2;
			if (episode <= ebase) {
				//X×~߂
				epsilon = 0.5 + 0.5 * double(episode) / double(ebase);
			}
			else {
				epsilon = 1.0;
				eta = 0.01;
			}

#pragma omp critical
			if (episode % 1000 == 0) {
				std::cout << "episode:" << ave << "-" << episode << std::endl;
			}

			double v0 = 2.0 * (0.5 - rand_real_0_1(mt));

			//ʒuxNgƑxxNg
			particles.rs[0].set(0, 0, 0);
			particles.vs[0].set(0, 0, 0);
			particles.rs[1].set(0, 0, L);
			particles.vs[1].set(v0, 0, 0);

			double dQ_ave = 0;
			//sCfbNX
			int n_f_box;
			int n_theta_now;

			double r_max = 0;

			int M = round((t_max - t_min) / dt);
			for (int i = 0; i <= M; i++) {
				double t = i * dt;

				//O
				particles.fx_ext = 0;


				if (i == 0) {

					//̏Ԃc
					n_theta_now = getThetaindex(particles);

					//^͂͂OƂȂCfbNX^
					n_f_box = N_f_box / 2;

					//Ԃ֗͂^
					particles.fx = f_box_min + (f_box_max - f_box_min) * n_f_box / N_f_box;

				}
				else if (i % int(interval / dt) == 0) {

					if (i % int(1.0 / dt) == 0) {
						//O
						particles.fx_ext = fx_ext_min + (fx_ext_max - fx_ext_min)*rand_real_0_1(mt);
					}

					//s̏Ԃc
					int n_theta_next = getThetaindex(particles);
					//std::cout << t << " " << particles.rs[0].x << " " << particles.rs[0].z << " " << particles.rs[1].x << " " << particles.rs[1].z << std::endl;
					//std::cout << n_theta_next << std::endl;

					//̌vZïʒuGlM[j
					double v2 = pow(particles.vs[1].x, 2) + pow(particles.vs[1].z, 2);
					double r = m * g * particles.rs[1].z - 1.0/2.0 * m * v2;

					//
					if (particles.rs[1].z < 0) {
						r += r_failure;
					}
					//
					if (i == M) {
						success++;
						timesOfSuccess[ave]++;
						r += r_success;
					}

					double maxQ = 0;
					for (int j = 0; j <= N_f_box; j++) {
						if (maxQ < Q[ave][j][n_theta_next]) {
							maxQ = Q[ave][j][n_theta_next];
						}
					}

					double dQ = (r + gamma * maxQ - Q[ave][n_f_box][n_theta_now]);

					//sl֐̍XV
					Q[ave][n_f_box][n_theta_now] = Q[ave][n_f_box][n_theta_now] + eta * dQ;


					////////////////////////////////////////////////////
					//̍švZX
					////////////////////////////////////////////////////
					n_theta_now = n_theta_next;

					maxQ = 0;
					int n_f_box_max = 10000;
					for (int j = 0; j <= N_f_box; j++) {
						if (maxQ < Q[ave][j][n_theta_now]) {
							maxQ = Q[ave][j][n_theta_now];
							n_f_box_max = j;
						}
					}
					//wK̏ꍇimaxQ=0j
					if (n_f_box_max == 10000) n_f_box_max = int(floor((N_f_box + 1) * rand_real_0_1(mt)));

					//n_f_box = n_f_box_max;

					if (rand_real_0_1(mt) < epsilon) {
						//s͍ő剿lsɌ
						n_f_box = n_f_box_max;
					}
					else {
						//s̓_Ɍ
						n_f_box = int(floor((N_f_box + 1) * rand_real_0_1(mt)));
					}

					//Ԃ֗͂^
					particles.fx = f_box_min + (f_box_max - f_box_min) * n_f_box / N_f_box;

					//Gs\[hI
					if (particles.rs[1].z < 0) {
						//std::cout << ":" << t << "[s]" << particles.rs[1].z << std::endl;
						break;
					}

					double _L = pow(particles.rs[0].x - particles.rs[1].x,2) + pow(particles.rs[0].z - particles.rs[1].z,2);

					if (_L > 1.1) {
						//std::cout << "b" << std::endl;
						error++;
						break;
					}

				}

				//QENb^@ɂ鎞ԔW
				particles.timeEvolution(t);

				for (int n = 0; n < 2; n++) {
					//ʒu̍XV
					particles.rs[n] = particles.rs[n] + particles.drs[n];
					//x̍XV
					particles.vs[n] = particles.vs[n] + particles.dvs[n];
				}

			}
			if (episode % ave_span == 0) {

#pragma omp atomic
				probabilityOfSuccess[ave][episode / ave_span] += double(success) / ave_span;

				success = 0;
			}

		}
	}

	//LO̍쐬
	int ranking[averageNum];
	bool ranking_flag[averageNum];
	for (int i = 0; i < averageNum; i++) {
		ranking_flag[i] = false;
	}
	for (int i = 0; i < averageNum; i++) {
		int _times = -1;
		int _ave;
		for (int j = 0; j < averageNum; j++) {

			if (ranking_flag[j]) continue;
			if (_times < timesOfSuccess[j]) {
				_times = timesOfSuccess[j];
				_ave = j;
			}
		}
		ranking[i] = _ave;
		ranking_flag[_ave] = true;
	}

	std::cout << "---------ʁi" << Episode << "wKj-e" << error <<"--------" << std::endl;
	for (int i = 0; i < averageNum; i++) {

		std::cout << i + 1 << " " << timesOfSuccess[ranking[i]] << "񐬌inum:" << ranking[i] << "j" << std::endl;

	}


	//t@C̐ݒ
	std::ostringstream filename1;
	filename1 << "output/20180619-ProbabilityOfSuccess_eta" << "_gamma" << gamma << "_epsilon_" << N_f_box << "_" << N_theta << "_" << r_success << ".txt";
	// t@Co̓Xg[̏
	std::ofstream ofs1(filename1.str());

	ofs1 << "#x:wK" << std::endl;
	ofs1 << "#y:" << std::endl;
	//ofs1 << "#legend:  " << std::endl;
	ofs1 << "#yrange:0 1 0.1" << std::endl;
	ofs1 << "#showLines: true true true true true" << std::endl;
	ofs1 << "#showMarkers: false false false false false" << std::endl;
	ofs1 << "#fills: false false" << std::endl;

	for (int i = 0; i <= Episode / ave_span; i++) {
		double p = 0;
		for (int j = 0; j < averageNum; j++) {
			p += probabilityOfSuccess[j][i] / averageNum;
		}
		ofs1 << i * ave_span;
		ofs1 << " " << probabilityOfSuccess[ranking[0]][i];
//		ofs1 << " " << probabilityOfSuccess[ranking[1]][i];
//		ofs1 << " " << probabilityOfSuccess[ranking[2]][i];
		ofs1 << " " << probabilityOfSuccess[ranking[averageNum - 1]][i];
		ofs1 << " " << p << std::endl;
	}
	ofs1.close();


	//t@C̐ݒ
	std::ostringstream filename2;
	filename2 << "output/20180619-BestQ_eta" << "_gamma" << gamma << "_epsilon" << "_" << r_success << ".txt";
	// t@Co̓Xg[̏
	std::ofstream ofs2(filename2.str());


	for (int j0 = 0; j0 < N_theta; j0++) {
		ofs2 << "#stateF" << std::endl << j0 << std::endl;
		ofs2 << "#action" << std::endl;
		for (int j1 = 0; j1 <= N_f_box; j1++) {
			ofs2 << " " << Q[ranking[0]][j1][j0];
		}
		ofs2 << std::endl;
	}
	ofs2.close();



	///////////////////////////////////////////////////////////
	// łwKi񂾋@Bɂ鐧̗lq̋L^
	///////////////////////////////////////////////////////////
	std::ostringstream data1;
	std::ostringstream data2;

	//QNb^IuWFNg̐
	Particles particles(2, dt);
	double v0 = 2.0 * (0.5 - rand_real_0_1(mt));

	//ʒuxNgƑxxNg
	particles.rs[0].set(0, 0, 0);
	particles.vs[0].set(0, 0, 0);
	particles.rs[1].set(0, 0, L);
	particles.vs[1].set(v0, 0, 0);

	//sCfbNX
	int n_f_box;
	int n_theta_now;

	double maxV=0;

	int M = round((t_max - t_min) / dt);
	for (int i = 0; i <= M; i++) {
		double t = i * dt;

		if (i == 0) {

			//̏Ԃc
			n_theta_now = getThetaindex(particles);

			//^͂͂OƂȂCfbNX^
			n_f_box = N_f_box / 2;

			//Ԃ֗͂^
			particles.fx = f_box_min + (f_box_max - f_box_min) * n_f_box / N_f_box;

		}
		else if (i % int(interval / dt) == 0) {

			if (i % int(1.0 / dt) == 0) {
				//O
				particles.fx_ext = fx_ext_min + (fx_ext_max - fx_ext_min)*rand_real_0_1(mt);
			}

			//s̏Ԃc
			int n_theta_next = getThetaindex(particles);


			////////////////////////////////////////////////////
			//̍švZX
			////////////////////////////////////////////////////
			n_theta_now = n_theta_next;

			double maxQ = 0;
			int n_f_box_max = 10000;
			for (int j = 0; j <= N_f_box; j++) {
				if (maxQ < Q[ranking[0]][j][n_theta_now]) {
					maxQ = Q[ranking[0]][j][n_theta_now];
					n_f_box_max = j;
				}
			}
			//wK̏ꍇimaxQ=0j
			if (n_f_box_max == 10000) n_f_box_max = int(floor((N_f_box + 1) * rand_real_0_1(mt)));

			//n_f_box = n_f_box_max;

			if (rand_real_0_1(mt) < epsilon) {
				//s͍ő剿lsɌ
				n_f_box = n_f_box_max;
			}
			else {
				//s̓_Ɍ
				n_f_box = int(floor((N_f_box + 1) * rand_real_0_1(mt)));
			}

			//Ԃ֗͂^
			particles.fx = f_box_min + (f_box_max - f_box_min) * n_f_box / N_f_box;

			//Gs\[hI
			if (particles.rs[1].z < 0) {
				//std::cout << ":" << t << "[s]" << particles.rs[1].z << std::endl;
				break;
			}
		}

		//ofs << t << " " << particles.rs[0].x << " " << particles.rs[0].y << " " << particles.rs[0].z << " " << particles.rs[1].x << " " << particles.rs[1].y << " " << particles.rs[1].z << std::endl;
		if (i % 10 == 0) data1 << particles.rs[0].x << " " << particles.rs[0].z << std::endl;
		if (i % 10 == 0) data2 << particles.rs[1].x << " " << particles.rs[1].z << std::endl;

		//QENb^@ɂ鎞ԔW
		particles.timeEvolution(t);

		for (int n = 0; n < 2; n++) {
			//ʒu̍XV
			particles.rs[n] = particles.rs[n] + particles.drs[n];
			//x̍XV
			particles.vs[n] = particles.vs[n] + particles.dvs[n];
		}

		double v2 = pow(particles.vs[1].x - particles.vs[0].x, 2) + pow(particles.vs[1].z - particles.vs[0].z, 2);
		if (maxV < sqrt(v2)) maxV = sqrt(v2);

	}

	double E1 = 1.0 / 2.0 * m_box * particles.vs[0].lengthSq() + m_box * g * particles.rs[0].z;
	double E2 = 1.0 / 2.0 * m * particles.vs[1].lengthSq() + m * g * particles.rs[1].z;

	double _L01 = Vector3::distance(particles.rs[1], particles.rs[0]);
	std::cout << "L=" << (_L01 - L) << " E=" << E1 + E2 << " maxV=" << maxV <<  std::endl;

	//t@C̐ݒ
	std::ostringstream filename;
	filename << "output/HorizontalFreePendulum.txt";
	// t@Co̓Xg[̏
	std::ofstream ofs(filename.str());

	ofs << "#x:xW" << std::endl;
	ofs << "#y:zW" << std::endl;
	ofs << "#legend:  " << std::endl;
	ofs << "#showLines: false false true true false false" << std::endl;
	ofs << "#showMarkers: true true false false true true" << std::endl;
	ofs << "#fills: false false false false" << std::endl;

	ofs << "#dataset:1 " << std::endl;
	ofs << data1.str() << std::endl;
	ofs << "" << std::endl;
	ofs << "#dataset:2 " << std::endl;
	ofs << data2.str() << std::endl;

	ofs.close();






















	std::cout << "finished" << std::endl;

	int a;
	std::cin >> a;
	return a;

}

/*
gccRpC
g++ -c Vector3.cpp -std=c++14 -O2
g++ -c RK4_Nbody.cpp -std=c++14 -O2
g++ -c main.cpp -std=c++14 -O2
g++ main.o Vector3.o RK4_Nbody.o
*/
